package Attributes;

use FindBin qw( $RealBin );
use lib "$RealBin/lib/AttributesC-src/blib/lib";
use lib "$RealBin/lib/AttributesC-src/blib/arch";

use AttributesC;
use strict;

# Funcions per determinar distancies entre vectors d'atributs

##############################################################################
# globals

my $ROOT;

##############################################################################
# functions

sub LoadAT
{
	my ($file) = @_;
	
	print "Loading AT...\n";
	
	$ROOT = new AttributesC::tNode;
	&AttributesC::ResetNode( $ROOT);
	
	my $nl = 0;
	open (F, $file) || die "ooh";
	while (my $l = <F>) {
		chomp($l);
		my @atr = split(/\,/, $l);
		pop(@atr) if ($atr[-1] !~ /^\d$/); # treiem la classe si hi és
		my $node = $ROOT;
		foreach my $a (@atr) {
			$node = &AttributesC::PushNode( $node, $a);
		}
		
		$nl++;
		if ($nl % 10000 == 0) {
			print "$nl\n";
		}
	}
	close (F);
	print "LOADED!\n";
}

sub Forget
{
	$ROOT = undef;
}

sub GetRoot
{
	my ($file) = @_;
	
	if (!defined($ROOT)) {
		# Carreguem l'arbre
		LoadAT($file);
	}
	return $ROOT;
}

sub MinDistance
{
	my ($atr, $umbral, $file) = @_;

	my $node = GetRoot($file);
	my $dist = 0;
	for (my $i = 0; $i < @$atr; $i++) {
		my $next = &AttributesC::NextNode( $node, $atr->[$i]);
		if (!defined($next)) {
			$next = &AttributesC::NextNode( $node, (1 - $atr->[$i]));
			$dist++;
			if ($dist > $umbral) {
				return $dist;
			}
		}
		$node = $next;
	}
	
	return $dist;
}




sub TreuContradictoris
{
	my ($file) = @_;
	my $fneg = "$file.neg0";
	
	Forget;
	
	# Carreguem en memoria els exemples negatius
# 	LoadAT($fneg);
	
	#-s 	File or directory exists and has nonzero size (the value is the size in bytes) 
	if (-s $fneg) {
		# Anem eliminant els exemples positius que tambe son negatius
		open (D, $file) || die "oops, no puc obrir $file: $!";
		open (DNET, ">$file.net") || die "oops, no puc obrir $file.net: $!";
		while (my $l=<D>) {
			chomp($l);
			my @atr = split(/\,/, $l);
			my $result = pop(@atr);
			if (MinDistance(\@atr, 0, $fneg) > 0) {
				print DNET "$l\n";
			}
		}
		close (DNET);
		close (D);
		
		system("mv $file $file.pos");
		system("cp $file.net $file");
	}
	else {
		system("cp $file $file.pos");
	}
}

1;
