package Edge;
use strict;
use Vertex;

sub new {
	my ($pkg, $a, $b) = @_;
	my $e = bless { _a => $a, _b => $b }, $pkg;
	return $e;
}

sub weight {
	my $obj = shift;
	@_ ? $obj->{_weight} = shift : $obj->{_weight};
}

sub adjacents
{
	my $obj = shift;
	return ($obj->{_a}, $obj->{_b});
}

sub incident {
	my ($obj, $v) = @_;
	
	if (defined($v) && 
		($v->id == $obj->{_a}->id || $v->id == $obj->{_b}->id)) {
		return 1;
	}
	return 0;
}

sub destination {
	my ($obj, $v) = @_;
	
	if (defined($v)) {
		if ($v->id == $obj->{_a}->id) {
			return $obj->{_b};
		}
		elsif ($v->id == $obj->{_b}->id) {
			return $obj->{_a};
		}
	}
	return undef;
}

sub DESTROY {
	my $obj = shift;
	undef($obj->{_a});
	undef($obj->{_b});
}

1;
