package Markable;
use strict;
use Document;

sub new {
	my ($pkg, $id) = @_;
	my $m = bless { id => $id, index => 0 }, $pkg;
	if ($id =~ /^\w+_(\d+)$/) {
		$m->index($1);
	}
	return $m;
}

# Copies a mention from another.
sub CopyFrom {
	my ($me, $other) = @_;
	foreach my $k (keys(%{$other})) {
		next if ($k eq 'span');
		$me->{$k} = $other->{$k};
	}
# 	$me->document($other->document);
	$me->span($other->{span_text});
}

sub document {
	my $obj = shift;
	@_ ? $obj->{_document} = shift : $obj->{_document};
}

sub id {
	my $obj = shift;
	@_ ? $obj->{id} = shift : $obj->{id};
}

sub index {
	my $obj = shift;
	@_ ? $obj->{index} = shift : $obj->{index};
}

sub infoextra {
	my $obj = shift;
	@_ ? $obj->{infoextra} = shift : $obj->{infoextra};
}

# for tokens
sub content {
	my $obj = shift;
	@_ ? $obj->{content} = shift : $obj->{content};
}

sub span {
	my ($m, $span) = @_;
	my $tokens = $m->document->tokens;

	@{$m->{span}} = ();
	foreach my $spanrange (split(/\,/, $span)) {
		if ($spanrange =~ /^word_(\d+)\.\.word_(\d+)$/) {
			$m->{span_ini} = $1;
			$m->{span_fi} = $2;
			for (my $a=$m->{span_ini}; $a <= $m->{span_fi}; $a++) {
				push(@{$m->{span}}, $tokens->[$a]);
			}
		}
		elsif ($spanrange =~ /^word_(\d+)$/) {
			my $i = $1;
			$m->{span_ini} = $i;
			$m->{span_fi} = $i;
			push(@{$m->{span}}, $tokens->[$i]);
		}
	}
	$m->{span_text} = $span;
	$m->string;
	return;
}

sub string {
	my $m = shift;
	
	if (!defined($m->{_string})) {
		my $text;
		# gets the content of each token
		if (defined($m->{span})) {
			foreach my $ref (@{$m->{span}}) {
				$text .= ' ' if ($text ne '');
				$text .= $ref->content;
			}
			$m->{_string} = $text;
		}
		# tokens does not have span. We get the content
		else {
			$m->{_string} = $m->content;
		}
		
		# substituim guions _ per espais
		$m->{_string} =~ s/_/ /og;
	}
	
	return $m->{_string};
}

sub DESTROY {
	my $m = shift;
	delete $m->{span} if (defined($m->{span}));
	$m->{_document} = undef;
}







1;
