#ifndef RELAXGRAPH_H
#define RELAXGRAPH_H

#include <vector>
#include <iostream>

using namespace std;

typedef struct {
	int adj;
	double weight;
} Constraint;


// Constraints d'ordre > 1
typedef struct {
	vector <int> adj;
	double weight;
	vector<vector<int> > inf;
} Constraint2;

typedef struct {
	vector <Constraint> constraints;
	vector <Constraint2> constraints2;
	vector <double> iniLabels;
	int label;
} Node;

typedef struct {
	vector <Node> nodes;
	vector<vector<double> > labels_a, labels_b;
	vector<vector<double> > *current;
} Problem;

void InitializeGraph(vector<Node> &nodes,
							vector<vector<double> > &labels_a,
							vector<vector<double> > &labels_b);
double NormalizeSupport(double x);
int MaxLabel(const vector<double> &x);
void Relaxation(Problem *p);

void RelaxationIni(Problem *p);
int RelaxationIter(Problem *p, int MaxIter);

void PushIniLabel( Node *n, double l);
void PushConstraint( Node *n, Constraint c);
void PushConstraint2( Node *n, Constraint2 c);
void PushAdjC2( Constraint2 *c, int v);
void PushInfC2( Constraint2 *c, int i, int v);
void PushNode( Problem *p, Node n);
int ReadNodeLabel( Problem *p, int index);

double ReadCurrentLabel( Problem *p, int node, int index);
void SetCurrentLabel( Problem *p, int node, int index, double value);

#endif
