package SolverSingleton;
require Solver;

our @ISA = qw(Solver);
use strict;
use Features;

sub model
{
	my ($obj) = @_;
	my $model = new DT($obj->{_modelFile});
	$model->mask($obj->mask);
	$model->alias($obj->modelAlias);
	$model->trueMentions($obj->trueMentions);
	return $model;
}

sub Solve
{
	my ($obj, $file, $opt) = @_;
	my $doc = new Document($file);
	my $mentions = $doc->GetMentions($obj->trueMentions);
	
	print "Solving: $file... (all singletons)\n" if ($obj->verbosity);
	
	my @response;
	for (my $i = 0; $i < @$mentions; $i++) {
		$mentions->[$i]->{chain} = $i;
	}
	
	$doc->SaveLevel($mentions, 'response');
	
	# free memory
	$doc->Clear;
}

1;
